//
//  TSGenerateRintoneOperation.swift
//  AIRingtone
//
//  Created by 100Years on 2025/3/21.
//

import Combine
import Alamofire
class TSGenerateRintoneOperation: TSBaseOperation , @unchecked Sendable{
    
    @Published var stateDatauPblished:(TSProgressState,TSActionInfoModel?) = (TSProgressState.none,nil){
        didSet{
            dePrint("stateDatauPblished didSet = \(stateDatauPblished)")
            
        }
    }
    
    private var creatRequest:Request?
    private var queryRequest:Request?
    private var stopNetwork = false
    private var generatingProgress = 0
    private var aiText:String = ""
    private var action_id:Int = 0    
    
   func creatRintone(text:String) {
       generatingProgress = 0
       aiText = text
       let postDict:[String : Any] = [
           "prompt":text,
           "duration":20
       ]
       stateDatauPblished = (.start,nil)
       stateDatauPblished = (.progressString(generating(progress: 0.0)),nil)
       creatRequest = TSNetworkShared.post(urlType: .musicCreate,parameters: postDict) { [weak self] data,error in
           guard let self = self else { return }
           if let dataDict = data as? [String:Any] ,
              dataDict.safeInt(forKey: "code") == 200,
              let actionId = dataDict["actionId"] as? Int{
               if stopNetwork == false {
                   self.getActionInfo(action_id:actionId)
               }
           }else{
               self.stateDatauPblished = (.failed(error?.localizedDescription ?? ""),nil)
           }
       }
   }
   
   func getActionInfo(action_id:Int){
       self.action_id = action_id
       queryRequest = TSNetworkShared.get(urlType: .actionInfo,parameters: ["action_id":action_id]) { [weak self] data,error in
           guard let self = self else { return }
           if let result = kNetWorkResultSuccess(data: data) {
               if let genmojiModel = TSActionInfoModel(JSON: result) {
                   switch genmojiModel.actionStatus {
                   case .success:
                       TSToastShared.hideLoading()
                       self.stateDatauPblished = (.success(nil),genmojiModel)
                       generatingProgress = 0
                   case .failed:
                       self.stateDatauPblished = (.failed(kNetWorkMessage(data: data) ?? ""),nil)
                       generatingProgress = 0
                   default:
                       stateDatauPblished = (.progressString(generating(progress: genmojiModel.percent)),nil)
                       if stopNetwork == false {
                           kDelayOnMainThread(1.0) {
                               self.getActionInfo(action_id: action_id)
                           }
                       }
                   }
               }
           }else{
               self.stateDatauPblished = (.failed(error?.localizedDescription ?? ""),nil)
           }
       }
   }
    func generating(progress:Float) -> String {

        //Generating 0%-100%
        var progressInt = Int(progress*100)

        if generatingProgress >= progressInt{
            return "Generating \(generatingProgress)%"
        }

        if progressInt > 99 {
            progressInt = 99
        }
        
        generatingProgress = progressInt
        return "Generating \(progressInt)%"
    }
    
    
    
    func cancelAllRequest(){
        creatRequest?.cancel()
        queryRequest?.cancel()
        stopNetwork = true
    }
    
    
}
